select
    an.numero as "NUMERO"
    , (select grausangue from sp_calculagrausangue(an.cdanimal)) as "GRAU DE SANGUE"
    , cast(((select count(*)
        from lactacao lac
        where lac.cdanimal = an.cdanimal
            and lac.dtinicio < pi.dtimplante)
        + (coalesce(an.numpartoentrada, 0))) as varchar(2)) as "ORDEM DE PARTO"
    , parant.data as "DATA DE PARTO"
    , pi.dtimplante as "DATA INICIO PROTOCOLO"
    , coalesce(ecc1antes.valor, ecc1depois.valor) as "ECC INICIO PROTOCOLO"
    , (case tent.cdtiporeproducao
        when 3 then coalesce(ecc2antes.valor, ecc2depois.valor)
        else NULL end) as "ECC NA TE"
    , (case
        when (exists (select * from reproducao re where re.cdanimal = an.cdanimal
            and((re.cdresultadoexameoe in (select cdresultadoexameginecologico
                from resultadoexameginecologico
                where upper(nomeresumido) like '%CL%'))
            or (re.cdresultadoexameod in (select cdresultadoexameginecologico
                from resultadoexameginecologico
                where upper(nomeresumido) like '%CL%')))
                    and re.data >= (pi.dtimplante - 12)
                    and re.data <= pi.dtimplante))
        then 'Sim' else 'No' end) as "PRESENA DE CL NO DIA DO PROTOCOLO"
    , (case tent.cio
        when 0 then 'No'
        when 1 then 'Sim'
        when 2 then 'Irregular'
    else null end)  as "EXTRA - Detalhe do cio"
    , (case tent.cdtiporeproducao
        when 3 then 'Sim'
        when 2 then 'No'
        when 1 then 'No'
        else 'No' end) as "RECEBEU EMBRIO"
    , (case
        when (dig.data - tent.data) > 23 then 'Sim'
        else 'No' end) as "DIAG. 30 DIAS"
    , (case
        when (dig.data - tent.data) > 55 then 'Sim'
        else 'No' end)as "DIAG 60 DIAS"
    , (case
        when (dig.dtpartoprovavel > current_date) and (proxtent.cdreproducao is null) then 'Sim'
    else 'No' end) as "PREVISO DE PARTO"
    ,(case
        when dig.cdtiporeproducao = 7 and tent.cdtiporeproducao = 3 then 'Sim'
    else 'No' end) as "PARIU DA TE"
from
    programacaoiatfassociacao pia
    join programacaoiatf pi on pi.cdprogramacaoiatf = pia.cdprogramacaoiatf
    join animal an on pia.cdanimal = an.cdanimal
    left join reproducao parant on parant.cdreproducao =
        (select first 1 re.cdreproducao
        from reproducao re
        where re.cdanimal = an.cdanimal
            and re.data < pi.dtimplante
            and re.cdtiporeproducao = 7
        order by re.data desc)
    left join reproducao tent on tent.cdreproducao =
        (select first 1 re.cdreproducao
        from reproducao re
        where re.cdanimal = an.cdanimal
            and re.data > pi.dtimplante
            and re.cdtiporeproducao = any (select cdtiporeproducao from tiporeproducao where cdtiporeproducao < 4)
        order by re.data asc)
    left join reproducao proxtent on proxtent.cdreproducao =
        (select first 1 re.cdreproducao
        from reproducao re
        where re.cdanimal = an.cdanimal
            and re.data > tent.data
            and re.cdtiporeproducao = any (select cdtiporeproducao from tiporeproducao where cdtiporeproducao < 4)
        order by re.data asc)        
    left join reproducao dig on dig.cdreproducao =
        (select first 1 re.cdreproducao
        from reproducao re
        where re.cdanimal = an.cdanimal
            and re.data > tent.data
            and re.data < (coalesce(proxtent.data, '2222-12-31'))
            and ((re.cdtiporeproducao = 4 and re.diagnostico = 'P')
                or (re.cdtiporeproducao = 7))
        order by re.data desc)
    left join medida ecc1antes on ecc1antes.cdmedida =
        (select first 1 rem.cdmedida
        from medida rem
        where rem.cdanimal = an.cdanimal
            and rem.dtmedida <= pi.dtimplante
            and rem.dtmedida > (pi.dtimplante - 7)
            and rem.cdtipomedida = 2
        order by rem.dtmedida desc)
    left join medida ecc1depois on ecc1depois.cdmedida =
        (select first 1 rem.cdmedida
        from medida rem
        where rem.cdanimal = an.cdanimal
            and rem.dtmedida > pi.dtimplante
            and rem.dtmedida < (pi.dtimplante + 7)
            and rem.cdtipomedida = 2
        order by rem.dtmedida desc)
    left join medida ecc2antes on ecc2antes.cdmedida =
        (select first 1 rem.cdmedida
        from medida rem
        where rem.cdanimal = an.cdanimal
            and rem.dtmedida <= tent.data
            and rem.dtmedida > (tent.data - 7)
            and rem.cdtipomedida = 2
        order by rem.dtmedida desc)
    left join medida ecc2depois on ecc2depois.cdmedida =
        (select first 1 rem.cdmedida
        from medida rem
        where rem.cdanimal = an.cdanimal
            and rem.dtmedida > tent.data
            and rem.dtmedida < (tent.data + 7)
            and rem.cdtipomedida = 2
        order by rem.dtmedida desc)
order by an.numordenado, pi.dtimplante
